<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_insurance".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderInsurance".
 *
 * Columns in table "provider_insurance" available as properties of the model,
 * followed by relations of table "provider_insurance" available as properties of the model.
 *
 * @property integer $id
 * @property integer $provider_id
 * @property integer $company_id
 * @property integer $insurance_id
 * @property string $date_added
 * @property string $date_updated
 *
 * @property Provider $provider
 */
abstract class BaseProviderInsurance extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_insurance';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderInsurance|ProviderInsurances', $n);
    }

    public static function representingColumn()
    {
        return 'date_added';
    }

    public function rules()
    {
        return array(
            array('provider_id, company_id, insurance_id, date_added', 'required'),
            array('provider_id, company_id, insurance_id', 'numerical', 'integerOnly'=>true),
            array('date_updated', 'safe'),
            array('date_updated', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, provider_id, company_id, insurance_id, date_added, date_updated', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
            'insurance' => array(self::BELONGS_TO, 'Insurance', 'insurance_id'),
            'company' => array(self::BELONGS_TO, 'InsuranceCompany', 'company_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'provider_id' => null,
            'company_id' => Yii::t('app', 'Company'),
            'insurance_id' => Yii::t('app', 'Insurance'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'provider' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('company_id', $this->company_id);
        $criteria->compare('insurance_id', $this->insurance_id);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
